from flask import Blueprint, request, render_template, flash
from .src import host_lookup
from markupsafe import escape

bp = Blueprint("lookup", __name__)


@bp.route("/lookup", methods=(["GET", "POST"]))
def lookup():
    hosts = []
    results = []
    if request.method == "GET":
        return render_template("lookup.html")
    elif request.method == "POST" and any(request.form.get("host")):
        print(f'REQUEST.FORM.GET("HOST") IS {request.form.get("host")}')
        user_input = escape(request.form.get("host").strip())
        hosts, errors = host_lookup.process_input(user_input)
        for host in hosts:
            result = host_lookup.Lookedup(host)
            results.append(result)
        return render_template("results.html", hosts=results, errors=errors)
    else:
        flash("Nothing entered! Try again?", "error")
        return render_template("lookup.html")


#    elif request.method == "POST" and "file" in request.files:
#        file = request.files["file"]
#        extracted = upload.extract(file)
#        hosts = host_lookup.process_file(extracted)
#        return render_template("results.html", hosts=hosts)
